gtkmm: Gtk::CellAreaContext Class Reference

gtkmm 3.4.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gtk::CellAreaContext Class Reference

This stores geometrical information for a series of rows in a CellArea. More...

Inheritance diagram for Gtk::CellAreaContext:
[legend]

List of all members.

## Public Member Functions
virtual | ~CellAreaContext ()
GtkCellAreaContext* | gobj ()
| Provides access to the underlying C GObject.
const GtkCellAreaContext* | gobj () const
| Provides access to the underlying C GObject.
GtkCellAreaContext* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< CellArea > | get_area ()
| Fetches the Gtk::CellArea this context was created by.
Glib::RefPtr< const CellArea > | get_area () const
| Fetches the Gtk::CellArea this context was created by.
void | allocate (int width, int height)
| Allocates a width and/or a height for all rows which are to be rendered with context.
void | reset ()
| Resets any previously cached request and allocation data.
void | get_preferred_width (int& minimum_width, int& natural_width) const
| Gets the accumulative preferred width for all rows which have been requested with this context.
void | get_preferred_height (int& minimum_height, int& natural_height) const
| Gets the accumulative preferred height for all rows which have been requested with this context.
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height) const
| Gets the accumulative preferred height for width for all rows which have been requested for the same said width with this context.
void | get_preferred_width_for_height (int height, int& minimum_width, int& natural_width) const
| Gets the accumulative preferred width for height for all rows which have been requested for the same said height with this context.
void | get_allocation (int& width, int& height) const
| Fetches the current allocation size for context.
void | push_preferred_width (int minimum_width, int natural_width)
| Causes the minimum and/or natural width to grow if the new proposed sizes exceed the current minimum and natural width.
void | push_preferred_height (int minimum_height, int natural_height)
| Causes the minimum and/or natural height to grow if the new proposed sizes exceed the current minimum and natural height.
Glib::PropertyProxy_ReadOnly < CellArea* > | property_area () const
| The Cell Area this context was created for.
Glib::PropertyProxy_ReadOnly< int > | property_minimum_width () const
| Minimum cached width.
Glib::PropertyProxy_ReadOnly< int > | property_natural_width () const
| Minimum cached width.
Glib::PropertyProxy_ReadOnly< int > | property_minimum_height () const
| Minimum cached height.
Glib::PropertyProxy_ReadOnly< int > | property_natural_height () const
| Minimum cached height.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gtk::CellAreaContext > | wrap (GtkCellAreaContext* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

This stores geometrical information for a series of rows in a CellArea.

CellAreaContext is used by widgets such as TreeView and IconView, but application developers do not usually need to be aware of it.

The CellAreaContext object is created by a given CellArea and is used to store cell sizes and alignments for a series of TreeModel rows that are requested and rendered in the same context.

CellLayout widgets can create any number of contexts in which to request and render groups of data rows. However. it's important that the same context which was used to request sizes for a given TreeModel row also be used for the same row when calling other CellArea APIs such as gtk_cell_area_render() and gtk_cell_area_event().

## Constructor & Destructor Documentation

virtual Gtk::CellAreaContext::~CellAreaContext | ( |  | ) | `[virtual]`

## Member Function Documentation

void Gtk::CellAreaContext::allocate | ( | int | width,
|  | int | height
| ) |  |

Allocates a width and/or a height for all rows which are to be rendered with context.

Usually allocation is performed only horizontally or sometimes vertically since a group of rows are usually rendered side by side vertically or horizontally and share either the same width or the same height. Sometimes they are allocated in both horizontal and vertical orientations producing a homogeneous effect of the rows. This is generally the case for Gtk::TreeView when Gtk::TreeView::property_fixed_height_mode() is enabled.

Since 3.0

Parameters:

  width | The allocated width for all Gtk::TreeModel rows rendered with context, or -1.
  height | The allocated height for all Gtk::TreeModel rows rendered with context, or -1.

void Gtk::CellAreaContext::get_allocation | ( | int & | width,
|  | int & | height
| ) |  | const

Fetches the current allocation size for context.

If the context was not allocated in width or height, or if the context was recently reset with reset(), the returned value will be -1.

Since gtkmm 3.0:

Parameters:

  width | Location to store the allocated width, or `0`.
  height | Location to store the allocated height, or `0`.

Glib::RefPtr<CellArea> Gtk::CellAreaContext::get_area | ( |  | ) |

Fetches the Gtk::CellArea this context was created by.

This is generally unneeded by layouting widgets; however it is important for the context implementation itself to fetch information about the area it is being used for.

For instance at Gtk::CellAreaContextClass.allocate() time its important to know details about any cell spacing that the Gtk::CellArea is configured with in order to compute a proper allocation.

Since gtkmm 3.0:

Returns:
  The Gtk::CellArea this context was created by.

Glib::RefPtr<const CellArea> Gtk::CellAreaContext::get_area | ( |  | ) | const

Fetches the Gtk::CellArea this context was created by.

This is generally unneeded by layouting widgets; however it is important for the context implementation itself to fetch information about the area it is being used for.

For instance at Gtk::CellAreaContextClass.allocate() time its important to know details about any cell spacing that the Gtk::CellArea is configured with in order to compute a proper allocation.

Since gtkmm 3.0:

Returns:
  The Gtk::CellArea this context was created by.

void Gtk::CellAreaContext::get_preferred_height | ( | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Gets the accumulative preferred height for all rows which have been requested with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are 0.

Since gtkmm 3.0:

Parameters:

  minimum_height | Location to store the minimum height, or `0`.
  natural_height | Location to store the natural height, or `0`.

void Gtk::CellAreaContext::get_preferred_height_for_width | ( | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Gets the accumulative preferred height for width for all rows which have been requested for the same said width with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are -1.

Since gtkmm 3.0:

Parameters:

  width | A proposed width for allocation.
  minimum_height | Location to store the minimum height, or `0`.
  natural_height | Location to store the natural height, or `0`.

void Gtk::CellAreaContext::get_preferred_width | ( | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Gets the accumulative preferred width for all rows which have been requested with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are 0.

Since gtkmm 3.0:

Parameters:

  minimum_width | Location to store the minimum width, or `0`.
  natural_width | Location to store the natural width, or `0`.

void Gtk::CellAreaContext::get_preferred_width_for_height | ( | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Gets the accumulative preferred width for height for all rows which have been requested for the same said height with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are -1.

Since gtkmm 3.0:

Parameters:

  height | A proposed height for allocation.
  minimum_width | Location to store the minimum width, or `0`.
  natural_width | Location to store the natural width, or `0`.

GtkCellAreaContext* Gtk::CellAreaContext::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GtkCellAreaContext* Gtk::CellAreaContext::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkCellAreaContext* Gtk::CellAreaContext::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::PropertyProxy_ReadOnly< CellArea* > Gtk::CellAreaContext::property_area | ( |  | ) | const

The Cell Area this context was created for.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_minimum_height | ( |  | ) | const

Minimum cached height.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_minimum_width | ( |  | ) | const

Minimum cached width.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_natural_height | ( |  | ) | const

Minimum cached height.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_natural_width | ( |  | ) | const

Minimum cached width.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::CellAreaContext::push_preferred_height | ( | int | minimum_height,
|  | int | natural_height
| ) |  |

Causes the minimum and/or natural height to grow if the new proposed sizes exceed the current minimum and natural height.

This is used by Gtk::CellAreaContext implementations during the request process over a series of Gtk::TreeModel rows to progressively push the requested height over a series of get_preferred_height() requests.

Since gtkmm 3.0:

Parameters:

  minimum_height | The proposed new minimum height for context.
  natural_height | The proposed new natural height for context.

void Gtk::CellAreaContext::push_preferred_width | ( | int | minimum_width,
|  | int | natural_width
| ) |  |

Causes the minimum and/or natural width to grow if the new proposed sizes exceed the current minimum and natural width.

This is used by Gtk::CellAreaContext implementations during the request process over a series of Gtk::TreeModel rows to progressively push the requested width over a series of get_preferred_width() requests.

Since gtkmm 3.0:

Parameters:

  minimum_width | The proposed new minimum width for context.
  natural_width | The proposed new natural width for context.

void Gtk::CellAreaContext::reset | ( |  | ) |

Resets any previously cached request and allocation data.

When underlying Gtk::TreeModel data changes its important to reset the context if the content size is allowed to shrink. If the content size is only allowed to grow (this is usually an option for views rendering large data stores as a measure of optimization), then only the row that changed or was inserted needs to be (re)requested with get_preferred_width().

When the new overall size of the context requires that the allocated size changes (or whenever this allocation changes at all), the variable row sizes need to be re-requested for every row.

For instance, if the rows are displayed all with the same width from top to bottom then a change in the allocated width necessitates a recalculation of all the displayed row heights using get_preferred_height_for_width().

Since 3.0

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::CellAreaContext > wrap | ( | GtkCellAreaContext * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/cellareacontext.h